# -*- coding: utf-8 -*-
from setuphelpers import *
import bs4 as BeautifulSoup
import zipfile
import requests
import platform


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    url = "https://nginx.org"
    bin_name = "nginx.exe"
    # Getting latest version from official website
    page = requests.get(url + "/en/download.html", headers={"User-Agent": "Mozilla/5.0 (Windows NT 6.1; Win64; x64)"}, proxies=proxies).text
    bs = BeautifulSoup.BeautifulSoup(page, "html.parser")
    bs_title = bs.find("h4", text="Stable version")
    url_dl = url + bs_title.findNext().findAll("a")[3]["href"]

    latest_bin_zip = url_dl.split("/")[-1]
    version = latest_bin_zip.replace(".zip", "").split("-")[-1]

    print("Latest " + app_name + " version is: " + version)
    print("Download url is: " + url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin_zip):
        print("Downloading: " + latest_bin_zip)
        wget(url_dl, latest_bin_zip, proxies=proxies)

        # Extracting
        with zipfile.ZipFile(latest_bin_zip, "r") as zip_file:
            for afile in zip_file.filelist:
                if afile.filename.endswith(bin_name):
                    nginx_exe = zip_file.extract(afile)
        filecopyto(nginx_exe, bin_name)
        remove_tree(os.path.abspath(os.path.join(nginx_exe, os.pardir)))
        remove_file(latest_bin_zip)

    # Checking version from file
    version_from_file = get_file_properties(bin_name)["ProductVersion"]
    if Version(version_from_file) != Version(version) and version_from_file != "":
        print("Changing version to the version number of the binary (from: %s to: %s)" % (version, version_from_file))
        version = version_from_file
    else:
        print("Binary file version corresponds to online version")

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        package_updated = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated
